<?php
# Copyright (c) 2008 MARIE Olivier. 
# Ce fichier fait partie du logiciel OMega-Annonces.
# OMega-Annonces est un logiciel libre ; vous pouvez le redistribuer et/ou le 
# modifier selon les termes de la GNU General Public License (Licence Publique 
# Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation ; 
# soit la version 2 de la licence, soit (comme vous le souhaitez) toute version 
# ultrieure.
# OMega-Annonces est distribu dans l'espoir qu'il sera utile, mais SANS LA 
# MOINDRE GARANTIE ; pas mme la garantie implicite de COMMERCIABILITE ou 
# d'ADEQUATION A UN BUT PARTICULIER.
# Voir la GNU General Public License pour plus de dtails.
# Vous devriez avoir reu une copie de la GNU General Public License en mme 
# temps que ce programme; sinon, merci d'crire  la Free Software Foundation, 
# Inc, 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

include("include/blocs_html_admin.inc.php");
include("include/fonctions_admin.inc.php");
include("../classes/Bien.class.php");
include("../classes/Photo.class.php");
include("../classes/Ville.class.php");
include("../classes/Type.class.php");
include("../classes/Attribut.class.php");
connexionBase();
controleAuth();
$phpSelf = $_SERVER["PHP_SELF"];
$affichageListe = true;

debut_html();
echo '<div id="adminCentre"><h2>Gestion des biens</h2>';


// Recherche des catgories
Categorie::retourFormulaireSelection();
if(empty($listeIdNomCategories)) {
	echo "Aucune catgorie n'est dfinie.<br>Vous devez tout d'abord dfinir une catgorie pour y insrer des biens.</div>";
	fin_html(); deconnexionBase(); exit;
}

// -----------------------------------------------------------------------------------------------------------------
// Chargement des donnes en fonction de la catgorie
// -----------------------------------------------------------------------------------------------------------------
$listeIdNomVilles = Ville::listeIdNomVilles();
if(empty($listeIdNomVilles)) {
	echo "Aucune ville n'est dfinie.<br>Vous devez tout d'abord dfinir au moins une ville pour crer un bien.</div>";
	fin_html(); deconnexionBase(); exit;
}
$listeIdNomAttributs = Attribut::listeIdNomAttributs($id_categorie);
$listeIdNomTypes = Type::listeIdNomTypes($id_categorie);


// -----------------------------------------------------------------------------------------------------------------
// RETOUR FORMULAIRE CREATION/MODIFICATION ---------------------------------------------
// -----------------------------------------------------------------------------------------------------------------
if(array_key_exists("retour_form",$_POST)) {

	$tmpBien = new Bien($_POST["id_bien"]);
	
	if(empty($tmpBien->id_bien)) { // nouveau bien
		$tmpBien->id_categorie = $id_categorie;
	}
	$tmpBien->id_ville = $_POST["id_ville"];
	if(!empty($_POST["adresse"])) {
	    $tmpBien->adresse = stripslashes($_POST["adresse"]);
	}
	if(!empty($_POST["accroche"])) {
	    $tmpBien->accroche = stripslashes(substr($_POST["accroche"],0,127));
	}

	$tmpBien->r_type_bien = array();
	foreach($listeIdNomTypes as $k=>$v) {
	    if(array_key_exists("id_type_".$k,$_POST)) {
            $tmpBien->r_type_bien[] = $k;
	    }
	}

	if(!empty($_POST["description"])) {
	    $tmpBien->description = stripslashes($_POST["description"]);
	}

	if(array_key_exists("visible",$_POST)) {
	    $tmpBien->visible = 1;
	} else {
	    $tmpBien->visible = 0;
	}

	if(array_key_exists("archive",$_POST)) {
	    $tmpBien->archive = 1;
	} else {
	    $tmpBien->archive = 0;
	}

	if(array_key_exists("best",$_POST)) {
	    $tmpBien->best = 1;
	} else {
	    $tmpBien->best = 0;
	}

	// retour formulaire attributs ------------------------------------------
	$tmpBien->r_attribut = array();
	foreach($listeIdNomAttributs as $k=>$v) {
		if(array_key_exists('id_attribut_'.$k.'_exists',$_POST)) {
			$tmpBien->r_attribut[$k] = intval($_POST["id_attribut_".$k]);
		}
	}
	//var_dump($tmpBien);
	
	$tmpBien->ecriture();
}


// -----------------------------------------------------------------------------------------------------------------
// RETOUR SUPPRESSION ---------------------------------------------
// -----------------------------------------------------------------------------------------------------------------
if(array_key_exists("supprimer",$_GET)) {
	if(is_numeric($_GET["supprimer"])) {
		$tempBien = new Bien($_GET["supprimer"]);
		if(empty($tempBien->id_bien)) {
			exit("Bien ".$_GET["supprimer"]." introuvable");
		}
		$tempBien->suppression();
	}
}

// -----------------------------------------------------------------------------------------------------------------
// RETOUR ARCHIVAGE ---------------------------------------------
// -----------------------------------------------------------------------------------------------------------------
if(array_key_exists("archiver",$_GET)) {
	if(is_numeric($_GET["archiver"])) {
		$tempBien = new Bien($_GET["archiver"]);
		if(empty($tempBien->id_bien)) {
			exit("Bien ".$_GET["archiver"]." introuvable");
		}
		$tempBien->changeArchivage();
	}
}


// -----------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------
// Gestion categorie : affichage du formulaire.
Categorie::formulaireSelection();



// -----------------------------------------------------------------------------------------------------------------
// ---------------------- FORMULAIRE DE CREATION-MODIFICATION ------------------------------
// -----------------------------------------------------------------------------------------------------------------
if(array_key_exists("nouveau",$_GET) || array_key_exists("modifier",$_GET)) {

	$tmpIdBien = null;
	if(array_key_exists("modifier",$_GET)) {
		$tmpIdBien = $_GET["modifier"];
	}
	$tmpBien = new Bien($tmpIdBien);
	
	?><form name="form_bien" action="<?php echo $phpSelf; ?>" method="POST">
	<input type="hidden" name="retour_form" value="1">
	<input type="hidden" name="id_bien" value="<?php echo $tmpIdBien; ?>">
	<table class="pliste">
		<tr><th colspan=2>Caractristiques principales <?php echo (empty($tmpIdBien)?"":" du bien n".$tmpIdBien);?>
		</th></tr>
		<?php
		if(!empty($listeIdNomTypes)) {
			$htmlTypes = '<tr><td valign=top nowrap><b>Type(s) correspondant(s)</b><br>(plusieurs rponses possibles)</td><td>';
			//$i=0;
			foreach($listeIdNomTypes as $k=>$v) {
				$htmlTypes .= ' <input type="checkbox" name="id_type_'.$k.'"'
				.(in_array($k,$tmpBien->r_type_bien)?' checked':'').'>'.str_replace(" ","&#160;",$v).'&#160; &#160;';
				//$i++;
				//if(($i % 3)==0) $htmlTypes .= '<br>';
			}
			echo $htmlTypes.'</td></tr>';
		}
		?>
		<tr><td valign=top width="30%">Accroche</td>
			<td width="70%"><input type="text" maxlength=50 size=50 name=accroche value="<?php echo htmlentities($tmpBien->accroche);?>"></td></tr>
		<tr><td valign=top nowrap>Ville o se situe ce bien&nbsp;</td><td><select name="id_ville">
		<!-- <option value="-1">Indfini</option> -->
		<?php
		foreach($listeIdNomVilles as $k=>$v) {
			echo '<option value='.$k
			.($tmpBien->id_ville==$k?' selected':'').'>'.$v.'</option>';
		}
		?>
		</select></td></tr>
		<tr><td valign=top>Adresse prcise<br><i>(n, rue, rsidence, lieu-dit)</i><br>
		La touche Entre fait un saut de paragraphe.<br>
		Maintenez la touche majuscule appuye + Entre pour faire un saut de ligne simple.</td>
			<td><textarea cols=50 rows=4 name=adresse><?php echo htmlentities($tmpBien->adresse); ?></textarea></td></tr>
		<tr><td valign=top>Description gnrale</td>
			<td valign=top><textarea cols=50 rows=8 name=description><?php echo htmlentities($tmpBien->description); ?></textarea>
			<?php
		if(!empty($tmpIdBien)) {
			$listePhotos = Photo::listeNumeros($tmpIdBien);
			if(!empty($listePhotos)) {
				$j=0;
				foreach($listePhotos as $numeroPhoto) {
					$photo = new Photo($tmpIdBien,$numeroPhoto);
					echo '<img alt="photo reduite" src="../photos/vignettes/'.$tmpIdBien.'_'.$numeroPhoto.'.png">&#160;';
					if((++$j)==4) break;
				}
			}
		}
		?>			
			
		</td></tr>
		<tr><td valign=top>Statut</td>
			<td><input type="checkbox" name="visible" <?php echo ($tmpBien->visible==1?'checked':''); ?>>Visible
			<input type="checkbox" name="archive" <?php echo ($tmpBien->archive==1?'checked':''); ?>>Archiv
			<input type="checkbox" name="best" <?php echo ($tmpBien->best==1?'checked':'') ; ?>>Coup de coeur</td></tr>
	</table>
	<br>
	<table class="pliste"><tr><th colspan=2>Attributs</th></tr>
	<tr><td width="50%" nowrap>
		<?php
		$htmlAttributs = '';
		$i=0;
		foreach($listeIdNomAttributs as $k=>$v) {
			$attribDefini = false;
			if(array_key_exists($k,$tmpBien->r_attribut)) {
				$attribDefini = true;
			}

			$htmlAttributs .= '<input type="checkbox" name="id_attribut_'.$k.'_exists" '
			.($attribDefini?' checked':'').'>Dfini - '.$v[0].'&nbsp;:&nbsp;';

			if($v[2]==2) { // Boolen
				$check = -1;
				if(array_key_exists($k,$tmpBien->r_attribut)) {
					$check = $tmpBien->r_attribut[$k];
				}
				$htmlAttributs .= '<input type="radio" name="id_attribut_'.$k.'" value=1'
				.($check==1?' checked':'').' '
				.'onclick="document.form_bien.id_attribut_'.$k.'_exists.checked=true;">Oui&nbsp;'
				.'&nbsp;<input type="radio" name="id_attribut_'.$k.'" value=0'
				.($check==0?' checked':'').' '
				.'onclick="document.form_bien.id_attribut_'.$k.'_exists.checked=true;">Non';
			} 
			else {
				if(array_key_exists($k,$tmpBien->r_attribut)) {
					$valeur = $tmpBien->r_attribut[$k];
				} else {
					$valeur = '';
				}
				$htmlAttributs .= '<input size="10" type="text" name="id_attribut_'.$k.'" '
				.'onclick="document.form_bien.id_attribut_'.$k.'_exists.checked=true;" '
				.'value="'.$valeur.'">';
			}
            $htmlAttributs .= '<br>';
            $i++;
            if($i==intval((1+sizeof($listeIdNomAttributs))/2)) {
                $htmlAttributs .= '</td><td width="50%" nowrap>';
            }
		}
		echo $htmlAttributs;
		?>
	</td></tr></table>
	<br>
	<input type="submit" value="enregistrer">
	<input type="button" value="abandonner" onclick="document.location.href='<?php echo $phpSelf; ?>';">
	</form>
	<script language="javascript" type="text/javascript">
		setTimeout("document.form_bien.accroche.focus()",1);
	</script>
	<?php
	$affichageListe = false;
}
else {
	echo "<input type='button' value='Nouveau bien' "
				."onclick=\"document.location.href='".$phpSelf."?nouveau=1';\">";
}

if($affichageListe == false) {
	echo '</div>';
	fin_html();
	deconnexionBase();
	exit;
}

// -----------------------------------------------------------------------------------------------------------------
// AFFICHAGE DE LA LISTE DES BIENS -------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------
$idBiens = Bien::listeIdBiens($id_categorie,null,0);

	
?><br>
<br><b>Biens disponibles</b><br>
<?php
affichageListe($idBiens);

$idBiens = Bien::listeIdBiens($id_categorie,null,1);
?><br>
<br><b>Biens archivs</b><br>
<?php
affichageListe($idBiens,true);

function affichageListe($idBiens,$b_archives=false) {
	global $listeIdNomTypes, $listeIdNomVilles, $phpSelf ;
	if(empty($idBiens)) {
		echo "Aucun bien";
	} else {
		$html = '<table class="pliste" width="100%">'
		.'<tr><th width="1%">N</th><th>Photos</th><th>Type</th><th>Accroche</th><th>Ville</th><th width="1%">Actions</th></tr>';
		$i = 0;
		foreach($idBiens as $id_bien) {
			$bien = new Bien($id_bien);
			$listePhotos = Photo::listeNumeros($id_bien);

			$html .= '<tr class="gris'.($i&1).($bien->visible).'">'
			.'<td nowrap class="cell_bar_horiz" align="center"><input type="button" '
			.'onclick="document.location.href=\'gestion_biens.php?'
			.'modifier='.$bien->id_bien.'\';" value="&#160;'.$bien->id_bien.'&#160;">'
			.($bien->visible==0?' (masqu)':'')
			.'</td><td>';
			if(!empty($listePhotos)) {
				$j=0;
				foreach($listePhotos as $numeroPhoto) {
					$photo = new Photo($id_bien,$numeroPhoto);
					$html .= '<img alt="photo reduite" width="30" src="../photos/vignettes/'.$id_bien.'_'.$numeroPhoto.'.png">&#160;';
					if((++$j)==4) break;
				}
			}
			$html .= '&#160;</td><td><font size=1>';
			foreach($bien->r_type_bien as $item) {
				$html.= $listeIdNomTypes[$item].', ';
			}
			$html = substr($html,0,-2).'</font> &nbsp;</td>'
			.'<td>'.$bien->accroche.'&nbsp; </td>'
			.'<td>'.(empty($bien->id_ville)?'Non dfini':$listeIdNomVilles[$bien->id_ville]).' </td>'
			.'<td nowrap>'
			.'<input type="button" value="Gestion photos" '
			.'onclick="document.location.href=\'gestion_photos.php?id_bien='.$id_bien.'\';">'
			.'<input type="button" value="Suppression" '
			."onclick=\"if (window.confirm('Attention la suppression est dfinitive et aucune trace ne sera "
			."conserve de ce bien. Pour conserver une trace du bien, annulez puis archivez le bien (bouton Modifier).')) "
			."{document.location.href='".$phpSelf."?supprimer=".$id_bien."';}\">"
			.'</td>'
			.'</tr>';
			$i++;

			/*.'<input type="button" value="Modifier" '
			.'onclick="document.location.href=\''.$phpSelf.'?modifier='.$id_bien.'\';">'*/
		}
		echo $html.'</table>';
	}
}
?>
</div>
<?php
fin_html();
deconnexionBase();
?>