<?php
# Copyright (c) 2008 MARIE Olivier. 
# Ce fichier fait partie du logiciel OMega-Annonces.
# OMega-Annonces est un logiciel libre ; vous pouvez le redistribuer et/ou le 
# modifier selon les termes de la GNU General Public License (Licence Publique 
# Gnrale GNU) telle qu'elle a t publie par la Free Software Foundation ; 
# soit la version 2 de la licence, soit (comme vous le souhaitez) toute version 
# ultrieure.
# OMega-Annonces est distribu dans l'espoir qu'il sera utile, mais SANS LA 
# MOINDRE GARANTIE ; pas mme la garantie implicite de COMMERCIABILITE ou 
# d'ADEQUATION A UN BUT PARTICULIER.
# Voir la GNU General Public License pour plus de dtails.
# Vous devriez avoir reu une copie de la GNU General Public License en mme 
# temps que ce programme; sinon, merci d'crire  la Free Software Foundation, 
# Inc, 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

class RechAvancee {
	var $id_categorie;
	var $id_types = array();
	var $id_attributs = array();
	var $id_villes = array();
	var $auxEnvirons = false;
	var $id_attributsVille = array();
	
	var $listeBiens = array();
	
	function RechAvancee() {
	}
	
	function lecturePost() {
		// catgorie
		$this->id_categorie = intval($_POST["formRechercheAvancee"]);
		
		// types
		$listeIdTypes = Type::listeIdTypes($this->id_categorie);
		foreach($listeIdTypes as $item) {
			if(array_key_exists("idType_".$item, $_POST)) {
				$this->id_types[] = $item;
			}
		}
		
		// attributs
		$listeIdNomAttributs = Attribut::listeIdNomAttributs($this->id_categorie);
		foreach($listeIdNomAttributs as $k=>$v) {
			if(!array_key_exists("idAttribut_".$k, $_POST) || $_POST["idAttribut_".$k]=="") continue;
			if($v[2]==2) { // Boolen
				$this->id_attributs[$k] = true;
			} 
			else { // Nombre
				$this->id_attributs[$k] = array($_POST["idAttribut_".$k."_minmax"], intval($_POST["idAttribut_".$k]));
			}
		}

		// Villes
		$listeIdVilles = Ville::listeIdVilles();
		foreach($listeIdVilles as $k) {
			if(array_key_exists("idVille_".$k, $_POST)) {
				$this->id_villes[] = $k;
			}
		}
		if(array_key_exists("auxEnvirons", $_POST)) {
			$this->auxEnvirons = true;
		}

        // Attributs de ville
		$listeIdNomAttrVille = AttrVille::listeIdNomAttrVille();
		foreach($listeIdNomAttrVille as $k=>$v) {
			if(array_key_exists("idAttrVille_".$k, $_POST)) {
				$this->id_attributsVille[] = $k;
			} 
		}
	}

    function recherche() {
        $debug=false;
    	if(empty($this->id_categorie)) {
    		ecrireLog("Erreur requete recherche avancee : id_categorie vide ".implode(":",$_POST));
    		exit("Erreur dans les parametres de la recherche avancee");
		}
		$listeBiensSatisfaisants = array();

    	$sql = 'SELECT DISTINCT oma_bien.id_bien FROM oma_bien, oma_r_type_bien'
    	.' WHERE oma_bien.id_bien=oma_r_type_bien.id_bien'
    	.' AND id_categorie='.$this->id_categorie;
    	if(!empty($this->id_types)) {
    		$sql .= ' AND id_type IN ('.implode(', ',$this->id_types).')';
    	}
    	$sql .= ' AND visible=1 AND archive=0';
    	$result = requeteSQL($sql);

		$listeBiens = array();
		while ($line = mysql_fetch_array($result)) {
			$listeBiens[] = intval($line[0]);
		}
		mysql_free_result($result);
		if(empty($listeBiens)) {
			return null;
		}

        // Etablissement de la liste des villes
        $listeVillesSatisfaisantes = array();
    	foreach($this->id_villes as $id_ville) {
    		if(!in_array($id_ville, $listeVillesSatisfaisantes)) {
    			$listeVillesSatisfaisantes[] = $id_ville;
    		}
    		if($this->auxEnvirons) {
        		$ville = new Ville();
        		$ville->id_ville = $id_ville;
    			$ville->chargementToutesVillesProches(10);
    			foreach($ville->toutes_villes_proches as $k=>$v) {
	        		if(!in_array($k, $listeVillesSatisfaisantes)) {
	        			$listeVillesSatisfaisantes[] = $k;
	        		}
    			}
    		}
    	}
    	if($debug) {
    		echo '<hr>Villes satisfaisantes :<br>';
    		var_dump($listeVillesSatisfaisantes);
    		echo '<hr>';
    	}
		
        foreach($listeBiens as $id_bien) {
        	$bien = new Bien($id_bien);
        	if($debug) echo '<b>Analyse Bien '.$id_bien.'</b><br>';
        	
        	if(!in_array($bien->id_ville,$listeVillesSatisfaisantes)) {
        		if($debug) echo 'n est pas dans la liste des villes satisfaisantes<br>';
        		continue;
        	}
   
			// attributs bien --------------------------------------------------
	        if(empty($this->id_attributs)) {
        		if($debug) echo 'Aucun attribut de bien demand<br>';
	        } 
	        else {
        		if($debug) echo 'Des attributs de biens ont t spcifis. Vrification...<br>';
	        	$lesAttributsSontSatisfaits = true;
	            foreach($this->id_attributs as $k=>$v) {
	                if(!array_key_exists($k,$bien->r_attribut)) {
            			$lesAttributsSontSatisfaits = false;
            			break;
	                }
	            	if(is_numeric($v)) { // boolean
	            		if( $v != $bien->r_attribut[$k] ) {
	            			$lesAttributsSontSatisfaits = false;
	            			break;
	            		}
	            	}
	            	else { // Nombre (tableau aumoins+valeur)
	            		if( ($v[0]=="mini" && $bien->r_attribut[$k] < $v[1])   // au minimum
	            		 || ($v[0]=="maxi" && $bien->r_attribut[$k] > $v[1])) { // au maximum
	            			$lesAttributsSontSatisfaits = false;
            				break;
	            		}
	            	}
	            }
	            if($lesAttributsSontSatisfaits==false) {
	        		if($debug) echo 'les attributs ne sont pas satisfaits<br>';
	            	continue;	// l'un des attributs n'est pas satisfait
	            }
	            else {
	        		if($debug) echo 'les attributs sont satisfaits<br>';
	            }
	        }
            
            // attributs ville -------------------------------------------------
            if(empty($this->id_attributsVille)) {
        		if($debug) echo 'Aucun attribut de ville demand<br>';
            }
            else {
        		if($debug) echo 'Des attributs de ville ont t spcifis. Analyse...<br>';
        		$villeDuBien = new Ville();
        		$villeDuBien->chargement($bien->id_ville);
        		$villeDuBien->chargementToutesVillesProches(10);
        		$villesAAnalyser = array($villeDuBien->id_ville);
        		foreach($villeDuBien->toutes_villes_proches as $k=>$v) {
        		    $villesAAnalyser[] = $k;
        		}
        		//echo '<hr>villes a analyser : ';var_dump($villesAAnalyser);echo '<hr>';
            	foreach($this->id_attributsVille as $id_attributsVille) {
	            	$cetAttributEstSatisfait = false;
	            	if($debug) {
	            	    $tmpAttrV = new AttrVille($id_attributsVille);
	            	    echo 'Analyse de l\'attribut '.$id_attributsVille.' ('.$tmpAttrV->nom.')<br>';
	            	}
		        	foreach($villesAAnalyser as $id_villeAnalyse) {
    	            	if($debug) echo 'On regarde la prsence de cet attribut dans la ville '.$id_villeAnalyse;
		        		$ville = new Ville();
		    			$ville->chargement($id_villeAnalyse);
    	            	if($debug) echo ' ('.$ville->nom.')<br>';
		    			if(in_array($id_attributsVille, $ville->r_attr_ville))  {
		    				$cetAttributEstSatisfait = true;
		    				break;
		    			}
		    		}
		    		if($cetAttributEstSatisfait==false) {
		    			break;
		    		}
		    	}
		    	if($cetAttributEstSatisfait==false) {
	        		if($debug) echo 'Les attributs de ville demands ne sont pas satisfaits<br>';
	    			continue;	// cet attribut demand n'apparait dans aucune ville, on passe au bien suivant
	    		}
	            else {
	        		if($debug) echo 'Les attributs de ville sont satisfaits<br>';
	            }
            }
            $listeBiensSatisfaisants[] = $id_bien;
        }
        if($debug) {
            echo '<hr><b><font color=blue>Liste biens satisfaisant aux critres : '
            .implode("-",$listeBiensSatisfaisants).'</font></b><hr>';
        }
        return $listeBiensSatisfaisants;
    }		
} 
?>